import env from 'zrender/lib/core/env';
import SVGPainter from 'zrender/lib/svg/Painter';
import { vNodeToString } from './SVGCore';
import { updateAttrs } from 'zrender/lib/svg/patch';
import { DOMParser } from '@xmldom/xmldom';
env.svgSupported = true;
global.DOMParser = DOMParser;
class CustomSVGPainter extends SVGPainter {
  constructor(root, storage, opts, id) {
    var _this$_svgDom$setZren, _this$_svgDom;
    // Prioritize taking the width and height set in the configuration;
    // if not available, then take the width and height set in the styles.
    const {
      width,
      height
    } = root.getChartSize();
    opts.width = opts.width || width;
    opts.height = opts.height || height;
    // @ts-ignore
    super(null, storage, opts);
    // @ts-ignore
    this._svgDom = this._oldVNode.elm = root.elm;
    // @ts-ignore
    (_this$_svgDom$setZren = (_this$_svgDom = this._svgDom).setZrenderId) === null || _this$_svgDom$setZren === void 0 || _this$_svgDom$setZren.call(_this$_svgDom, id);
    // @ts-ignore
    updateAttrs(null, this._oldVNode);
    this.root = root;
  }
  refresh() {
    const vnode = this.renderToVNode({
      willUpdate: true
    });
    // Disable user selection.
    vnode.attrs.style = 'position:absolute;left:0;top:0;user-select:none';
    // @ts-ignore
    if (this._svgDom.patch) {
      // @ts-ignore
      this._svgDom.patch(this._oldVNode, vnode);
      // @ts-ignore
    } else if (this._svgDom.patchString) {
      // @ts-ignore
      this._svgDom.patchString(this._oldVNode, vNodeToString(vnode));
    }
    // @ts-ignore
    this._oldVNode = vnode;
  }
  toDataURL(base64) {
    var _this$_svgDom$makeIma, _this$_svgDom2;
    // @ts-ignore
    return ((_this$_svgDom$makeIma = (_this$_svgDom2 = this._svgDom).makeImageSnapshot) === null || _this$_svgDom$makeIma === void 0 ? void 0 : _this$_svgDom$makeIma.call(_this$_svgDom2)) || super.toDataURL(base64);
  }
}
export function SVGRenderer(registers) {
  registers.registerPainter('svg', CustomSVGPainter);
}
//# sourceMappingURL=SVGRenderer.js.map